/****************************************************************************\
*
* magnetiX - Magnetic Scrolls Interpreter - Mac OS X port
*
* Written by Jan-Sebastian Schliemann <magnetiX@maczentrisch.de>
*
*
* the original Magnetic was:
*
* Written by Niclas Karlsson <nkarlsso@abo.fi>,
*            David Kinder <davidk.kinder@virgin.net>,
*            Stefan Meier <Stefan.Meier@if-legends.org> and
*            Paul David Doherty <pdd@if-legends.org>
*
* Copyright (C) 1997-2008  Niclas Karlsson
*
*
*
*     This program is free software; you can redistribute it and/or modify
*     it under the terms of the GNU General Public License as published by
*     the Free Software Foundation; either version 2 of the License, or
*     (at your option) any later version.
*
*     This program is distributed in the hope that it will be useful,
*     but WITHOUT ANY WARRANTY; without even the implied warranty of
*     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*     GNU General Public License for more details.
*
*     You should have received a copy of the GNU General Public License
*     along with this program; if not, write to the Free Software
*     Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.
*
\*****************************************************************************/

#import "WA_4SonomaAnimation.h"

@implementation WA_4SonomaAnimation

- (instancetype)initWithView:(NSView *)view
				  startFrame:(NSRect)startFrame
					endFrame:(NSRect)endFrame
					   view2:(NSView *)view2
				 startFrame2:(NSRect)startFrame2
				   endFrame2:(NSRect)endFrame2
			 completionBlock:(void (^)(void))completionBlock
{
	self = [super init];
	if (self) {
		self.view = view;
		self.startFrame = startFrame;
		self.endFrame = endFrame;
		
		self.view2 = view2;
		self.startFrame2 = startFrame2;
		self.endFrame2 = endFrame2;
		
		self.completionBlock = completionBlock;
	}
	return self;
}

- (void)setCurrentProgress:(NSAnimationProgress)progress
{
	NSRect currentFrame = NSMakeRect(
		_startFrame.origin.x + progress * (_endFrame.origin.x - _startFrame.origin.x),
		_startFrame.origin.y + progress * (_endFrame.origin.y - _startFrame.origin.y),
		_startFrame.size.width + progress * (_endFrame.size.width - _startFrame.size.width),
		_startFrame.size.height + progress * (_endFrame.size.height - _startFrame.size.height)
	);

	_view.frame = currentFrame;
	
	currentFrame = NSMakeRect(
		_startFrame2.origin.x + progress * (_endFrame2.origin.x - _startFrame2.origin.x),
		_startFrame2.origin.y + progress * (_endFrame2.origin.y - _startFrame2.origin.y),
		_startFrame2.size.width + progress * (_endFrame2.size.width - _startFrame2.size.width),
		_startFrame2.size.height + progress * (_endFrame2.size.height - _startFrame2.size.height)
	);

	_view2.frame = currentFrame;
	_view2.layer.opacity = 1.0 + ((0.3 - 1.0) * progress);
	
	if (progress == 1.0) {
		self.completionBlock();
	}
}


- (void)dealloc
{
	self.completionBlock = nil;
	[super dealloc];
}


@end
